#ident	"$Header: /var/cvsroot/htdb/src/dso/crypto.c,v 1.4 2006/01/08 00:20:15 del Exp $"

/*
	Copyright  1994-2006 David Whittemore
	<del@adjective.com>, all rights reserved.

	Permission to use, copy, modify, and non-commercially distribute
	this software and its documentation for any purpose is hereby granted
	without fee, provided that the above copyright notice appear in all
	copies and that both that copyright notice and this permission notice
	appear in supporting documentation.  No representations are made about
	the suitability of this software for any purpose.  It is provided
	"as is" without express or implied warranty.
 */
#include	"htdb.h"

char	*dso_encrypt(char *source)
{
	return DSO_RETURNS_SUCCESS_ASIS(htdb_encryptor("pe1", source));
}

char	*dso_be1(char *source)
{
	return DSO_RETURNS_SUCCESS_ASIS(htdb_encryptor("be1", source));
}

char	*dso_se1(char *source)
{
	return DSO_RETURNS_SUCCESS_ASIS(htdb_encryptor("se1", source));
}

char	*dso_pe1(char *source)
{
	return DSO_RETURNS_SUCCESS_ASIS(htdb_encryptor("pe1", source));
}

/*
	dso_crypto()

		this is really an internal function - used to dynamically
		create encryptor/decryptor functions based upon encryptor
		definitions found in config.htdb.
 */
char	*dso_crypto(char *source)
{
	char	**args,
			*out = (char *)NULL;
	int		num_args = htdb_splitArgs(source, ",", &args, 2);

	if (num_args == 2) {
		out = htdb_encryptor(args[0], args[1]);
		htdb_deleteArgs(args, num_args);
		return DSO_RETURNS_SUCCESS_ASIS(out);
	}

	htdb_deleteArgs(args, num_args);
	return DSO_RETURNS_SUCCESS_CHALLENGED("");
}
